"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetWordBlacklist = exports.WordBlacklistMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var logger = log4js.getLogger('Sql');
var sqlConn;
function WordBlacklistMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.WordBlacklistMSSql = WordBlacklistMSSql;
function GetWordBlacklist(vcc, processId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ProcessId', sql.VarChar(50), processId)
        .execute('GetWordBlacklist')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetWordBlacklist = GetWordBlacklist;
