"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MSSql = void 0;
var AuthMSSql = require("./mssql/auth.mssql");
var BatchMSSql = require("./mssql/batch.mssql");
var BatchErrorMSSql = require("./mssql/batch-error.mssql");
var BatchScheduleMSSql = require("./mssql/batch-schedule.mssql");
var CustomFieldMSSql = require("./mssql/custom-field.mssql");
var DiarizationMSSql = require("./mssql/diarization.mssql");
var DictionaryMSSql = require("./mssql/dictionary.mssql");
var DomainMSSql = require("./mssql/domain.mssql");
var EntityMSSql = require("./mssql/entity.mssql");
var EvaluationTipificationMSSql = require("./mssql/evaluation-tipification.mssql");
var InteractionEvaluationPlanMSSql = require("./mssql/interaction-evaluation-plan.mssql");
var SentimentMSSql = require("./mssql/sentiment.mssql");
var TeamPerformanceMSSql = require("./mssql/team-performance.mssql");
var TipificationMSSql = require("./mssql/tipification.mssql");
var VCCMSSql = require("./mssql/vcc.mssql");
var VCCLicenseMSSql = require("./mssql/vcc-license.mssql");
var HomeMSSql = require("./mssql/home.mssql");
var NotificationMSSql = require("./mssql/notification.mssql");
var ProfileImageMSSql = require("./mssql/profile-image.mssql");
var ReportMSSql = require("./mssql/report.mssql");
var RoleMSSql = require("./mssql/role.mssql");
var UserMSSql = require("./mssql/user.mssql");
var ApiUserMSSql = require("./mssql/api-user.mssql");
var AzureSubscriptionMSSql = require("./mssql/azure-subscription.mssql");
var ClientMSSql = require("./mssql/client.mssql");
var ProcessMSSql = require("./mssql/process.mssql");
var EnvironmentMSSql = require("./mssql/environment.mssql");
var AllegroMSSql = require("./mssql/allegro.mssql");
var AudiosMSSql = require("./mssql/audio.mssql");
var IdathaMSSql = require("./mssql/idatha.mssql");
var FeelingMSSql = require("./mssql/feeling.mssql");
var CategoryMSSql = require("./mssql/category.mssql");
var NeuroLinguisticProgrammingMSSql = require("./mssql/neuro-linguistic-programming.mssql");
var TemplateMSSql = require("./mssql/template.mssql");
var CustomTemplateMSSql = require("./mssql/custom-template.mssql");
var GenericTemplateMSSql = require("./mssql/generic-template.mssql");
var GenericQueryMSSql = require("./mssql/generic-query.mssql");
var NLUMSSql = require("./mssql/nlu.mssql");
var IntentMSSql = require("./mssql/intent.mssql");
var UtteranceMSSql = require("./mssql/utterance.mssql");
var CommentMSSql = require("./mssql/tag.mssql");
var StudyMSSql = require("./mssql/study.mssql");
var WordBlacklistMSSql = require("./mssql/word-blacklist.mssql");
var TagMSSql = require("./mssql/tag.mssql");
var IntegrationMSSql = require("./mssql/integration.mssql");
var CampaignFulfillmentMSSql = require("./mssql/campaign-fulfillment.mssql");
var AverageGroupRatingMSSql = require("./mssql/average-group-rating.mssql");
var AverageGroupRatingNormMSSql = require("./mssql/average-group-rating-norm.mssql");
var TopBestAgentsMSSql = require("./mssql/top-best-agents.mssql");
var TopWorstAgentsMSSql = require("./mssql/top-worst-agents.mssql");
var InteractionsByTypeMSSql = require("./mssql/interactions-by-type.mssql");
var AbilityMSSql = require("./mssql/ability.mssql");
var SubgroupMSSql = require("./mssql/subgroup.mssql");
var GroupMSSql = require("./mssql/group.mssql");
var ExceptionMSSql = require("./mssql/exception.mssql");
var EvaluationFormatMSSql = require("./mssql/evaluation-format.mssql");
var CampainMSSql = require("./mssql/campain.mssql");
var InteractionMSSql = require("./mssql/interaction.mssql");
var EvaluationPlanMSSql = require("./mssql/evaluation-plan.mssql");
var InteractionTypeMSSql = require("./mssql/interaction-type.mssql");
var EvaluationMSSql = require("./mssql/evaluation.mssql");
var EvaluationReviewMSSql = require("./mssql/evaluation-review.mssql");
var AuditorMSSql = require("./mssql/auditor.mssql");
var AgentMSSql = require("./mssql/agent.mssql");
var SupervisorMSSql = require("./mssql/supervisor.mssql");
var VersionMSSql = require("./mssql/version.mssql");
var TenantVCCMSSql = require("./mssql/tenant-vcc.mssql");
var AsyncInteractionMSSql = require("./mssql/async-interaction.mssql");
var DispositionCodeMSSql = require("./mssql/disposition-code.mssql");
var MSSql = {};
exports.MSSql = MSSql;
Object.assign(MSSql, AuthMSSql, BatchMSSql, BatchErrorMSSql, BatchScheduleMSSql, CustomFieldMSSql, DiarizationMSSql, DictionaryMSSql, DomainMSSql, EntityMSSql, EvaluationTipificationMSSql, InteractionEvaluationPlanMSSql, SentimentMSSql, TeamPerformanceMSSql, TipificationMSSql, VCCMSSql, VCCLicenseMSSql, HomeMSSql, NotificationMSSql, ProfileImageMSSql, ReportMSSql, RoleMSSql, ApiUserMSSql, AzureSubscriptionMSSql, UserMSSql, ClientMSSql, ProcessMSSql, EnvironmentMSSql, AllegroMSSql, AudiosMSSql, IdathaMSSql, FeelingMSSql, CategoryMSSql, NeuroLinguisticProgrammingMSSql, TemplateMSSql, CustomTemplateMSSql, GenericTemplateMSSql, GenericQueryMSSql, NLUMSSql, IntentMSSql, UtteranceMSSql, CommentMSSql, StudyMSSql, WordBlacklistMSSql, TagMSSql, IntegrationMSSql, CampaignFulfillmentMSSql, AverageGroupRatingMSSql, AverageGroupRatingNormMSSql, TopBestAgentsMSSql, TopWorstAgentsMSSql, InteractionsByTypeMSSql, AbilityMSSql, SubgroupMSSql, GroupMSSql, ExceptionMSSql, EvaluationFormatMSSql, CampainMSSql, DispositionCodeMSSql, InteractionMSSql, EvaluationPlanMSSql, InteractionTypeMSSql, EvaluationMSSql, EvaluationReviewMSSql, AuditorMSSql, AgentMSSql, VersionMSSql, ApiUserMSSql, SupervisorMSSql, TenantVCCMSSql, AsyncInteractionMSSql);
