"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteScoreTipificationItem = exports.SaveScoreTipificationItem = exports.DeleteScoreTipificationQuery = exports.SaveScoreTipificationQuery = exports.DeleteScoreTipification = exports.SaveScoreTipification = exports.GetAbilityTitle = exports.GetScores = exports.SaveAbilityQueryEntity = exports.GetAbilityQueryEntities = exports.DeleteAbilityQueries = exports.SaveAbilityQuery = exports.GetAbilityQueries = exports.GetAbility = exports.DeleteAbility = exports.DeleteScore = exports.SaveScore = exports.SaveAbility = exports.GetAbilitys = exports.GetAbilityDetail = exports.AbilityMSSql = void 0;
var log4js = require("log4js");
var sql = require('mssql');
var score_model_1 = require("../../models/score.model");
var logger = log4js.getLogger('Sql');
var sqlConn;
function AbilityMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.AbilityMSSql = AbilityMSSql;
function GetAbilityDetail(vcc, id) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), id)
        .execute('GetAbilityDetail')
        .then(function (recordsets) {
        var rows = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(rows);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityDetail = GetAbilityDetail;
function GetAbilitys(vcc, search_criteria, search_expression, disabled) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetAbilitys')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilitys = GetAbilitys;
function SaveAbility(vcc, id, title, detail, type, calificationType, binary, notApply, distribute, acceptComments, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled, analysisType, language, isNegative, degradeScoreCard) {
    if (calificationType === void 0) { calificationType = null; }
    if (isNegative === void 0) { isNegative = false; }
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('Title', sql.VarChar(100), title)
        .input('Detail', sql.VarChar(500), detail)
        .input('Type', sql.VarChar(25), type)
        .input('CalificationType', sql.VarChar(25), calificationType)
        .input('Binary', sql.Bit, binary)
        .input('NotApply', sql.Bit, notApply)
        .input('Distribute', sql.Bit, distribute)
        .input('AcceptComments', sql.Bit, acceptComments)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('Enabled', sql.Bit(), enabled)
        .input('AnalysisType', sql.VarChar(25), analysisType)
        .input('Language', sql.VarChar(50), language)
        .input('IsNegative', sql.Bit(), isNegative)
        .input('DegradeScoreCard', sql.Bit(), degradeScoreCard)
        .execute('SaveAbility')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbility = SaveAbility;
function SaveScore(vcc, id, idAbility, scoreDescription, scoreValue) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .input('Description', sql.VarChar(100), scoreDescription)
        .input('Value', sql.Numeric(5, 1), scoreValue)
        .execute('SaveScore')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScore = SaveScore;
function DeleteScore(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .execute('DeleteScore')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScore = DeleteScore;
function DeleteAbility(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), idAbility)
        .execute('DeleteAbility')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAbility = DeleteAbility;
function GetAbility(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), idAbility)
        .execute('GetAbility')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var ability = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(ability);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbility = GetAbility;
function GetAbilityQueries(vcc, abilityId, evaluationPlanId) {
    if (evaluationPlanId === void 0) { evaluationPlanId = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetAbilityQueries')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityQueries = GetAbilityQueries;
function SaveAbilityQuery(vcc, abilityQueryId, abilityId, queryId, queryContent, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), abilityQueryId)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .input('QueryId', sql.VarChar(50), queryId)
        .input('QueryContent', sql.VarChar(1000), queryContent)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveAbilityQuery')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbilityQuery = SaveAbilityQuery;
function DeleteAbilityQueries(vcc, abilityId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityId', sql.VarChar(50), abilityId)
        .execute('DeleteAbilityQueries')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteAbilityQueries = DeleteAbilityQueries;
function GetAbilityQueryEntities(vcc, abilityQueryId, evaluationPlanId) {
    if (evaluationPlanId === void 0) { evaluationPlanId = null; }
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityQueryId', sql.VarChar(50), abilityQueryId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetAbilityQueryEntities')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityQueryEntities = GetAbilityQueryEntities;
function SaveAbilityQueryEntity(vcc, abilityQueryId, entityId, entityName, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('AbilityQueryId', sql.VarChar(50), abilityQueryId)
        .input('EntityId', sql.VarChar(50), entityId)
        .input('EntityName', sql.VarChar(50), entityName)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveAbilityQueryEntity')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbilityQueryEntity = SaveAbilityQueryEntity;
function GetScores(vcc, idAbility) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .execute('GetScores')
        .then(function (recordsets) {
        var scores = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : []);
        var tipifications = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 0 ? recordsets[1] : []);
        var tipificationsQuery = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 1 ? recordsets[2] : []);
        var tipificationItems = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) > 2 ? recordsets[3] : []);
        tipifications.forEach(function (t) {
            t.tipificationQuery = tipificationsQuery.find(function (tq) { return tq.tipificationId === t.id && tq.scoreId === t.scoreId; }) || new score_model_1.ScoreTipificationQuery();
            t.items = tipificationItems.filter(function (ti) { return ti.tipificationId === t.id && ti.scoreId === t.scoreId; });
        });
        scores.forEach(function (s) { return s.tipifications = tipifications.filter(function (t) { return t.scoreId === s.id; }); });
        return Promise.resolve(scores);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetScores = GetScores;
function GetAbilityTitle(vcc, title) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('Title', sql.VarChar(100), title)
        .execute('GetAbilityTitle')
        .then(function (recordsets) {
        var recordset = (recordsets && recordsets.length > 0 ? recordsets[0] : null);
        var ability = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(ability);
    }).catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityTitle = GetAbilityTitle;
function SaveScoreTipification(vcc, scoreId, id, description, detail, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), id)
        .input('Description', sql.VarChar(250), description)
        .input('Detail', sql.VarChar(500), detail)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveScoreTipification')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipification = SaveScoreTipification;
function DeleteScoreTipification(vcc, scoreId, tipificationId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), tipificationId)
        .execute('DeleteScoreTipification')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipification = DeleteScoreTipification;
function SaveScoreTipificationQuery(vcc, scoreId, tipificationId, queryId, queryContent, acceptancePercentage, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('QueryId', sql.VarChar(50), queryId)
        .input('QueryContent', sql.VarChar(sql.MAX), queryContent)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .execute('SaveScoreTipificationQuery')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipificationQuery = SaveScoreTipificationQuery;
function DeleteScoreTipificationQuery(vcc, scoreId, tipificationId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .execute('DeleteScoreTipificationQuery')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipificationQuery = DeleteScoreTipificationQuery;
function SaveScoreTipificationItem(vcc, scoreId, tipificationId, id, secondLevelItemId, description, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('ID', sql.VarChar(50), id)
        .input('SecondLevelItemId', sql.VarChar(50), secondLevelItemId)
        .input('Description', sql.VarChar(250), description)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveScoreTipificationItem')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveScoreTipificationItem = SaveScoreTipificationItem;
function DeleteScoreTipificationItem(vcc, scoreId, tipificationItemId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), tipificationItemId)
        .execute('DeleteScoreTipificationItem')
        .then(function (recordsets) {
        var recordset = ((recordsets === null || recordsets === void 0 ? void 0 : recordsets.length) ? recordsets[0] : null);
        var output = ((recordset === null || recordset === void 0 ? void 0 : recordset.length) ? recordset[0] : null);
        return Promise.resolve((output === null || output === void 0 ? void 0 : output.result) === 1);
    })
        .catch(function (err) {
        var errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteScoreTipificationItem = DeleteScoreTipificationItem;
