"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VCCProduct = exports.RequestData = exports.ProductVCC = exports.VCCAux = exports.IntegratedVCC = exports.VCC = void 0;
var VCC = (function () {
    function VCC(vcc, id, description, country, language, timeZone, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.id = id;
        this.description = description;
        this.country = country;
        this.language = language;
        this.timeZone = timeZone;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.changedCognitiveEngine = false;
        this.deleteDataDays = 360;
        this.totalNlu = 0;
        this.totalIntent = 0;
        this.totalUtterance = 0;
        this.totalEntity = 0;
        this.inUseModels = false;
    }
    return VCC;
}());
exports.VCC = VCC;
var IntegratedVCC = (function () {
    function IntegratedVCC() {
    }
    return IntegratedVCC;
}());
exports.IntegratedVCC = IntegratedVCC;
var VCCAux = (function () {
    function VCCAux(vcc, id, description, country, language, timeZone, products, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.id = id;
        this.description = description;
        this.country = country;
        this.language = language;
        this.timeZone = timeZone;
        this.products = products;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.type = null;
        this.cognitiveEngine = null;
        this.selected = false;
        this.cognitiveEngineCharsLimit = 0;
    }
    return VCCAux;
}());
exports.VCCAux = VCCAux;
var ProductVCC = (function () {
    function ProductVCC(accountId, subAccountId, products, vcc, availableBalance, asignableBalance, transcriptionRatePerHour, transcriptionRatePerSecond, semanticAnalysisRatePerTransaction, cognitiveAnalysisRatePerTransaction, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, timeStamp) {
        if (accountId === void 0) { accountId = ''; }
        if (subAccountId === void 0) { subAccountId = ''; }
        if (products === void 0) { products = []; }
        if (transcriptionRatePerHour === void 0) { transcriptionRatePerHour = 0.00001; }
        if (transcriptionRatePerSecond === void 0) { transcriptionRatePerSecond = 0.00001; }
        if (semanticAnalysisRatePerTransaction === void 0) { semanticAnalysisRatePerTransaction = 0.00001; }
        if (cognitiveAnalysisRatePerTransaction === void 0) { cognitiveAnalysisRatePerTransaction = 0.00001; }
        this.accountId = accountId;
        this.subAccountId = subAccountId;
        this.products = products;
        this.vcc = vcc;
        this.availableBalance = availableBalance;
        this.asignableBalance = asignableBalance;
        this.transcriptionRatePerHour = transcriptionRatePerHour;
        this.transcriptionRatePerSecond = transcriptionRatePerSecond;
        this.semanticAnalysisRatePerTransaction = semanticAnalysisRatePerTransaction;
        this.cognitiveAnalysisRatePerTransaction = cognitiveAnalysisRatePerTransaction;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.timeStamp = timeStamp;
    }
    return ProductVCC;
}());
exports.ProductVCC = ProductVCC;
var RequestData = (function () {
    function RequestData() {
    }
    return RequestData;
}());
exports.RequestData = RequestData;
var VCCProduct = (function () {
    function VCCProduct(product, availableLicense, assign, updatedValue) {
        this.product = product;
        this.availableLicense = availableLicense;
        this.assign = assign;
        this.updatedValue = updatedValue;
        this.selected = false;
    }
    return VCCProduct;
}());
exports.VCCProduct = VCCProduct;
