"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeSpecialCharacters = exports.removeAccents = exports.getInteractionIdFromURLBase64 = exports.sleep = exports.getRandomHexColor = exports.shuffle = exports.dateFromStrOfServiceCall = exports.guid = void 0;
var moment = require("moment");
var dateFormatForService = 'YYYY-MM-DD HH:mm:ss';
function guid() {
    var uuidV4 = require('uuid/v4');
    return uuidV4();
}
exports.guid = guid;
function dateFromStrOfServiceCall(s) {
    return moment(s, dateFormatForService).toDate();
}
exports.dateFromStrOfServiceCall = dateFromStrOfServiceCall;
function shuffle(array) {
    var currentIndex = array.length, temporaryValue, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}
exports.shuffle = shuffle;
function getRandomHexColor() {
    var letters = "0123456789ABCDEF", color = "#", c;
    for (c = 0; c < 6; c++) {
        color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
}
exports.getRandomHexColor = getRandomHexColor;
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
exports.sleep = sleep;
function getInteractionIdFromURLBase64(urlBase64) {
    var result = null;
    if (urlBase64 && urlBase64.length) {
        var url = Buffer.from(urlBase64, 'base64').toString(), array = url.split('/');
        if (array && array.length) {
            var id = array[9], section = array[10], part = array[11];
            result = {
                id: id,
                section: section,
                part: part,
                url: url
            };
        }
    }
    return result;
}
exports.getInteractionIdFromURLBase64 = getInteractionIdFromURLBase64;
function removeAccents(text) {
    return text.normalize("NFD").replace(/[\u0300-\u036f]/g, "");
}
exports.removeAccents = removeAccents;
function removeSpecialCharacters(text) {
    var specialCharacters = ['\\', '[', ']', '^', '$', '.', '|', '¿', '?', '¡', '!', '*', '+', '(', ')'];
    specialCharacters.map(function (sc) {
        text = text.split(sc).join('\\' + sc);
    });
    return text;
}
exports.removeSpecialCharacters = removeSpecialCharacters;
